"use strict";
var utils_1 = require("./utils");
function wrapSerialize(self) {
    return function (mapper, data, opts) {
        var beforeSerialize = opts.beforeSerialize || mapper.beforeSerialize || self.options.beforeSerialize, afterSerialize = opts.afterSerialize || mapper.afterSerialize || self.options.afterSerialize;
        if (beforeSerialize)
            data = beforeSerialize.call(self, mapper, data, opts);
        data = jsonApiSerialize.call(self, mapper, data, opts);
        if (afterSerialize)
            data = afterSerialize.call(self, mapper, data, opts);
        return data;
    };
}
exports.wrapSerialize = wrapSerialize;
function jsonApiSerialize(mapper, data, opts) {
    var id = data[mapper.idAttribute];
    delete data[mapper.idAttribute];
    utils_1.mapperCacheRelationByField(mapper);
    if (opts.changes && id && mapper.changes(id)) {
        var changes = mapper.changes(id);
        console.info('changes', changes);
    }
    var relationships = {};
    for (var key in data) {
        var relation = mapper.relationByFieldId[key];
        if (relation) {
            relationships[relation.localField] = {
                data: {
                    type: relation.relation,
                    id: data[key]
                }
            };
            delete data[key];
        }
    }
    var output = {
        data: {
            type: mapper.name,
            attributes: data
        }
    };
    if (id)
        output.data.id = id;
    if (Object.keys(relationships).length) {
        output.data.relationships = relationships;
    }
    return output;
}
exports.jsonApiSerialize = jsonApiSerialize;
//# sourceMappingURL=serializer.js.map